cd /Users/boydstun/Dropbox/A/_PROJECTS/nyt/book/analysis/

clear
version 11.2
capture log close
set mem 400m
set matsize 800
set more off

log using 5A_congestion.log, replace

************************************************************************************************************************
*  	Created By:		AEB                                                                                              	
*  	Creation Date:  11 May 2011                                                                                          	
*	Revised By:																											
*	Revised Date:																								
*  	Directory:      /Users/boydstun/Dropbox/A/_PROJECTS/nyt/book/analysis/       	       														
*  	Do-file-name:   5A_congestion.do 		                                                                    	    
*  	Purpose:        Calculate NYT agenda congestion across topics by month                                                     	    
*  	Data Input:     3_nyt_ftpg_collapsed_by_month.dta								                                      	
*  	Log File:       5A_congestion.log    	                                                                          	
*  	Data Output:    	
*  	Computer Name:  Longstockings                                                                                     		  	
*  	NOTES:               	
*
*  		         	To use this do file on another computer, adjust the cd (change directory) command at the top accordingly 
*					Questions: aboydstun@gmail.com   
************************************************************************************************************************

***********************************
* Input data and organize dataset *
***********************************

* NYT front-page data
*use 3_nyt_ftpg_collapsed_by_week.dta, replace
use 3_nyt_ftpg_collapsed_by_month.dta, replace

*keep week majortopic*
keep month majortopic*
	
gen	subentropy	=	0																			
gen	numtopics	=	0																			
egen	total	=	rowtotal(majortopic1	-	majortopic99)															
*foreach i of numlist	1 2 3 4 5 6 7 8 10 12 13 14 15 16 17 18 19 20 21	{
foreach i of numlist	1 2 3 4 5 6 7 8 10 12 13 14 15 16 17 18 19 20 21 24 26 27 28 29 30 31 99	{
	gen	prop`i'	=	majortopic`i'/total																	
	recode	prop`i'	(0=.000000000000000001)																			
	replace	subentropy	=	subentropy	+	(	prop`i'	*	ln(	prop`i'	))											
	replace	numtopics	=	numtopics	+	1																
	}																					
replace	subentropy	=	-	(	subentropy	)																
gen	diversity	=	(	subentropy	/	ln(	numtopics	))		
gen congestion = 1 - diversity												
																																																																																																																										
*keep week congestion*
*sort week 
keep month congestion*
sort month 
																						
*save 5A_congestion_by_week.dta, replace
save 5A_congestion_by_month.dta, replace

